////////////////////////////////////////////////////////////////////////////////
//    Copyright  by 21 (2002) All rights reserved :)                         //
////////////////////////////////////////////////////////////////////////////////
unit mwin;
////////////////////////////////////////////////////////////////////////////////
interface
////////////////////////////////////////////////////////////////////////////////
uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     Menus, StdCtrls, ComCtrls, editos;
////////////////////////////////////////////////////////////////////////////////
type
////////////////////////////////////////////////////////////////////////////////

  //struktura pro ulozeni nejdulezitejsich udaju
  TOsoba=class
    jm,pr,ph:string;
    id:string;
  end;

  //Hlavni okno programu
  TMainWin = class(TForm)
    OpenXml: TOpenDialog;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Otevt1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    RodoTree: TTreeView; //stromova struktura,kde jsou ulozeni lide
    Edit: TEdit;
    ListRodo: TListBox; //seznam lidi
    Upravit: TButton;
    procedure Konec1Click(Sender: TObject);
    procedure Otevt1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure RodoTreeChange(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
    procedure UpravitClick(Sender: TObject);
    procedure ListRodoDblClick(Sender: TObject);
  private
    ActOs:TOsoba;            //pri pridavani - prave pridavany clovek
    pnts:array of TTreeNode; //seznam ukazatelu na treenode kde je ulozen clovek  (index je stejny jako index v seznamu lidi)

    procedure ZpracujCast(st,ptag:string; node:TTreeNode);
    function  KoncovyTag(s:string):boolean;
    function  MalaPismena(s:string):string;
    function  StejnyTag(s1,s2:string):boolean;
    function  CistyTag(s:string):string;
    function  Matkaindex(s:string):string;
    function  Otecindex(s:string):string;

  public
    Osoby:TList; //seznam nejdulezitejsich informaci o kazdem cloveku
  end;
////////////////////////////////////////////////////////////////////////////////
var MainWin: TMainWin;
////////////////////////////////////////////////////////////////////////////////
implementation
{$R *.DFM}
////////////////////////////////////////////////////////////////////////////////
// prevede retezec na velka pismena

function UpStr(s:string):string;
var i:integer;
    ret:string;
begin
  for i:=1 to length(s) do ret:=ret+upCase(s[i]);
  Result:=ret;
end;

////////////////////////////////////////////////////////////////////////////////
// prevede pismeno na male

function DownCase(ch:Char):Char;
asm
  CMP AL,'A'
  JB  @@exit
  CMP AL,'Z'
  JA  @@exit
  SUB AL,'A' - 'a'
@@exit:
end;

////////////////////////////////////////////////////////////////////////////////
// prevede cely retezec  na mala pismena

function TMainWin.MalaPismena(s:string):string;
var i:integer;
    ret:string;
begin
  for i:=1 to length(s) do ret:=ret+DownCase(s[i]);
  Result:=ret;
end;

////////////////////////////////////////////////////////////////////////////////
// zjisti zda je tag stejny (i jestli je koncovy stejny jao zacinajici) (<a> = </a>)

function TMainWin.StejnyTag(s1,s2:string):boolean;
var t1,t2:string;
    i:integer;
begin
  for i:=1 to length(s1) do if (s1[i]<>'/') then t1:=t1+s1[i];
  for i:=1 to length(s2) do if (s2[i]<>'/') then t2:=t2+s2[i];
  result:=t1=t2;
end;

////////////////////////////////////////////////////////////////////////////////
// Ukoncit program

procedure TMainWin.Konec1Click(Sender: TObject);
begin
  Close;
end;

////////////////////////////////////////////////////////////////////////////////
// Zjisti zda je zadany tag koncovy (obsahuje "/")

function TMainWin.KoncovyTag(s:string):boolean;
var i:integer;
begin
  result:=true;
  for i:=1 to length(s) do if s[i]='/' then exit;
  result:=false;
end;

////////////////////////////////////////////////////////////////////////////////
// Vraci jen jmeno tagu (odreze zbytecne znacky) napr. "<A>" => "A"

function TMainWin.CistyTag(s:string):string;
var i:integer;
    ret:string;
begin
  ret:='';
  for i:=1 to length(s) do if (s[i]<>'/') and (s[i]<>'<') and (s[i]<>'>') then  ret:=ret+s[i];
  result:=ret;
end;

////////////////////////////////////////////////////////////////////////////////
// (nacita soubor) Zpracovava cast souboru ulozenou ve stringu
//  napred nalezne zacatek tagu na nejvyssi urovni, pote najde konec tohoto tagu
//  prida tag do stromove struktury a zavola se rekurzivne na tu cast mezi zacatkem a koncem tagu

procedure TMainWin.ZpracujCast(st,ptag:string; node:TTreeNode);
var i,Vnor:integer;
    bTag,bPrvni:boolean;
    tag,sPrvniTag:string;
    pStart,pEnd:integer;
    Data:PChar;
begin
  ptag:=CistyTag(ptag);  //zjistit jemno
  if ptag<>'' then node:=RodoTree.Items.AddChild(node,ptag); //pridat polozku
  if (node<>nil) then node.Data:=nil;
  if (ptag='osoba') then begin // pokud osoba tak vytvori novou osobu
    Actos:=TOsoba.Create;
  end;
  if (ptag='jmeno') then actos.jm:=st; //nastavit hodnoty aktualni osoby
  if (ptag='id') then actos.id:=st;
  if (ptag='pohlavi') then actos.ph:=st;
  if (ptag='prijmeni') then actos.pr:=st;
  if (ptag='id') or (ptag='jmeno') or (ptag='prijmeni') or (ptag='pohlavi') or (ptag='narozeni') or (ptag='umrti') or (ptag='matka') or (ptag='otec') then begin
    GetMem(Data,length(st)+1);  //naalokuje prostor a nastavi hodnotu
    st:=st+#0;
    strcopy(Data,@st[1]);
    node.Data:=Data;
  end;
  bPrvni:=true;
  bTag:=false;  //najde tag na nejvyssi urovni
  for i:=0 to length(st) do begin
    if st[i]='<' then begin
      bTag:=true;
    end;
    if bTag then begin
      tag:=tag+st[i];
    end;
    if st[i]='>' then begin
      if (bPrvni) and (not KoncovyTag(tag)) then begin
        pStart:=i+1;
        sPrvniTag:=MalaPismena(tag);
        bPrvni:=false;
        Vnor:=0;
      end;
      if (not bPrvni) and (not KoncovyTag(tag)) and StejnyTag(tag,sPrvniTag) then inc(vnor);
      if (not bPrvni) and (KoncovyTag(tag)) and StejnyTag(tag,sPrvniTag) then begin
        dec(vnor);
        if vnor=0 then begin
          pEnd:=i+1-length(tag); //pokud je tag na nej. urovni zpracuje rekurzivne cast souboru
          ZpracujCast(copy(st,pStart,pEnd-pStart),tag,node);
          bPrvni:=true;
        end;
      end;
      tag:='';
      bTag:=false;
    end;
  end;
  if (ptag='osoba') then begin //nastavit novou osobu a pridat do seznamu
    ListRodo.Items.Add(actos.jm+' '+ActOs.pr);
    if (upstr(actos.ph)<>'Z') then begin //pridat zeny do ComboBoxu na upravu matek
      EditDlg.ComboBox1.Items.Add(actos.jm+' '+ActOs.pr);
      setlength(EditDlg.otecid,EditDlg.ComboBox1.Items.count);
      editdlg.Otecid[EditDlg.ComboBox1.Items.count-1]:=actos.id;
    end;
    if (upstr(actos.ph)<>'M') then begin //pridat muze do ComboBoxu na upravu otcu
      EditDlg.ComboBox2.Items.Add(actos.jm+' '+ActOs.pr);
      setlength(EditDlg.matkaid,EditDlg.ComboBox2.Items.count);
      editdlg.matkaid[EditDlg.ComboBox2.Items.count-1]:=actos.id;
    end;
    setlength(pnts,ListRodo.Items.Count);
    pnts[ListRodo.Items.Count-1]:=node;
    Osoby.Add(ActOs);
  end;
end;

////////////////////////////////////////////////////////////////////////////////
// nacte obsah souboru a spusti jeho zpracovani

procedure TMainWin.Otevt1Click(Sender: TObject);
var s,sVse:string;
    f:textfile;
begin
  if OpenXml.Execute then begin
    try
      assignfile(f,openxml.FileName);
      reset(f);
      while not eof(f) do begin
        readln(f,s);
        sVse:=sVse+s;
      end;
      ZpracujCast(sVse,'',nil);
      closefile(f);
    except
      ShowMessage('Dolo k chyb pi natn souboru !');
    end;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
// uvolnit vsechnu pamet

procedure TMainWin.FormDestroy(Sender: TObject);
var i:integer;
begin
  for i:=0 to RodoTree.Items.Count-1 do begin
    if RodoTree.Items.Item[i].Data<>nil then FreeMem(RodoTree.Items.Item[i].Data);
  end;
  for i:=0 to Osoby.Count-1 do begin
    TOsoba(osoby.Items[i]).Free;
  end;
  Osoby.Free;
end;

////////////////////////////////////////////////////////////////////////////////
// pri zmene vybrane polozky ve strome nastavit hodnotu do vystupu

procedure TMainWin.RodoTreeChange(Sender: TObject; Node: TTreeNode);
begin
  Edit.Text:=PChar(Node.Data);
end;

////////////////////////////////////////////////////////////////////////////////
// vytvorit seznam osob

procedure TMainWin.FormCreate(Sender: TObject);
begin
  Osoby:=TList.Create;
end;

////////////////////////////////////////////////////////////////////////////////
// otevrit dialog pro upravu osoby

procedure TMainWin.UpravitClick(Sender: TObject);
var it:TTReeNode;
begin
if ListRodo.ItemIndex<0 then exit;
  it:=pnts[ListRodo.ItemIndex].getFirstChild;
  editdlg.osoba:=it;
  EditDlg.Nuluj;
  while (it<>nil) do begin // nastavit data osoby
    if it.Text='osoba' then break;
    if (it.text='matka') then EditDlg.Zpracuj(it.Text,Matkaindex(PChar(it.Data)))
    else if it.text='otec' then EditDlg.Zpracuj(it.Text,Otecindex(PChar(it.Data)))
    else EditDlg.Zpracuj(it.Text,PChar(it.Data));
    it:=it.GetNext;
  end;
  EditDlg.ShowModal; //zobrazit dialog
  ListRodo.Items[ListRodo.ItemIndex]:=EditDlg.Edit1.Text+' '+EditDlg.Edit2.Text; // upravit jmena v seznamu
end;

////////////////////////////////////////////////////////////////////////////////
// zjsiti index matky podle IDcka

function TMainWin.Matkaindex(s:string):string;
var i,ii:integer;
begin
  for i:=0 to Osoby.Count-1 do begin
    result:='0';
    if TOsoba(Osoby.Items[i]).id=s then begin
      for ii:=0 to EditDlg.ComboBox1.Items.Count-1 do
        if EditDlg.ComboBox1.Items[ii]=TOsoba(osoby.Items[i]).jm+' '+TOsoba(osoby.Items[i]).pr then begin result:=inttostr(ii); exit; end;
    end;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
// zjisti index otce podel IDcka

function TMainWin.Otecindex(s:string):string;
var i,ii:integer;
begin
  for i:=0 to Osoby.Count-1 do begin
    result:='0';
    if TOsoba(Osoby.Items[i]).id=s then begin
      for ii:=0 to EditDlg.ComboBox2.Items.Count-1 do
        if EditDlg.ComboBox2.Items[ii]=TOsoba(osoby.Items[i]).jm+' '+TOsoba(osoby.Items[i]).pr then begin result:=inttostr(ii); exit; end;
    end;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
// upravit

procedure TMainWin.ListRodoDblClick(Sender: TObject);
begin
  UpravitClick(nil);
end;

////////////////////////////////////////////////////////////////////////////////
end.
